\\ Copyright 2021 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0);
default(strictargs,1);
read("a349008-HA.gp");
read("my-oeis.gp");

check_count = 0;
check_equal(got,want,name="") =
{
  check_count++;
  if(got != want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------
\\ A349008 a() hull area

{
  my(want=[
 0,2,16,106,578,2954,15064,75908,380334,1904330,9528618,47654840,238295096,
 1191556256,5957936770,29789860126,148950201902,744752899780,3723767329212,
 18618843605284,93094240114350,465471240742354,2327356261817746,11636781564585616
]);
  check_equal(vector(#want,n,n--; a(n)), want, "a() vs DATA");
}

\\------------------------------------------------------------------------------
\\ Versus r5dragon.tex

print("read r5dragon-defines.gp");
read("r5dragon-defines.gp");

{
  my(u,v);
  gettime(); u=vector(400,n,n--; a(n));  print("time a()  = ",gettime());
  gettime(); v=vector(400,n,n--; HA(n)); print("time HA() = ",gettime());
  check_equal(u,v);
}

{
  check_equal(vector(1000,n,n--; a(n)),
              vector(1000,n,n--; HA(n)),
              "a() vs HA()");
}

\\------------------------------------------------------------------------------
check_equal(d,'d, "d not a global");
check_equal(k,'k);
check_equal(m,'m);
check_equal(n,'n);
check_equal(n,'n);
check_equal(p,'p);
check_equal(r,'r);
check_equal(v,'v, "v not a global");
check_equal(HAf,'HAf);
check_equal(ret,'ret);

\\------------------------------------------------------------------------------
print("end");


\\ UNUSED:
\\ 
\\ \\ 
\\ \\ a(n) grows as a power 5^n and limit a(n)/5^n -> A349009 = "HAf" which is
\\ \\ the area of the hull around the R5 dragon fractal.
\\ \\
\\ \\ The sum formula presented in A349009 is exactly a(n)/5^n, after some
\\ \\ simplifications.
\\ {
\\   my(n = 20,
\\      area=a(n),
\\      r=area/5^n,
\\      den=10^n);
\\   
\\   printf("Limit a(n)/5^n -> A349009 = HAf fractal hull area: eg. at n=%d\n", n);
\\   printf("           a(n) =  %s\n", area);
\\   printf("       a(n)/5^n =  %s / %s\n",
\\          numerator(r), denominator(r));
\\   printf("                =  %s / %s\n",
\\          r*den, den);
\\   printf("  cf actual HAf = .976164002912703513406407...\n");
\\ }
