\\ Copyright 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default("recover",0);
read("r5dragon-defines.gp");

check_count = 0;
check_exact(got,want, name="") =
{
  check_count++;
  if(got!= want,
     print("\nwrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count"  "name));
}

\\-----------------------------------------------------------------------------

{
D_samples = [[],
             [],
             [],
             [1,3,9,27,81],
             [1,3,9,27],
             [1,3,9,27],
             [1,3,9,27],
             [1,3,9,27],
             [1,3,9],
             [1,3,9],
             [1,3,9],
             [1,3,9],
             [1,3,9],
             [1,3,9],
             [1,3,9],
             [1,3,9],
             [1,3,9],
             [1,3,9],
             [1,3,9],
             [1,3,9],
             [1,3,9]
            ];
V_samples = [[],
             [],
             [],
             [1,3,9,27,81],
             [1,4,16,64],
             [1,5,25,125],
             [1,6,36,216],
             [1,7,49,343],
             [1,8,64],
             [1,9,81],
             [1,10,100],
             [1,11,121],
             [1,12,144],
             [1,13,169],
             [1,14,196],
             [1,15,225],
             [1,16,256],
             [1,17,289],
             [1,18,324],
             [1,19,361],
             [1,20,400]
            ];
W_samples = [[],
             [],
             [],
             [0,4,120,3276,88560],
             [0,9,516,25872],
             [0,16,1480,117400],
             [0,25,3390,389700],
             [0,36,6720,1055460],
             [0,49,12040],
             [0,64,20016],
             [0,81,31410],
             [0,100,47080],
             [0,121,67980],
             [0,144,95160],
             [0,169,129766],
             [0,196,173040],
             [0,225,226320],
             [0,256,291040],
             [0,289,368730],
             [0,324,461016],
             [0,361,569620]
            ];
wC_samples = [[],
             [],
             [],
             [0,3,36,351,3240],
             [0,5,80,1040],
             [0,7,140,2275],
             [0,9,216,4212],
             [0,11,308,7007],
             [0,13,416],
             [0,15,540],
             [0,17,680],
             [0,19,836],
             [0,21,1008],
             [0,23,1196],
             [0,25,1400],
             [0,27,1620],
             [0,29,1856],
             [0,31,2108],
             [0,33,2376],
             [0,35,2660],
             [0,37,2960]
            ];
}

\\-----------------------------------------------------------------------------

StarRep_wC_by_recurrence(s,k) =
{
  if(k==0,return(0));

  s*StarRep_wC_by_recurrence(s,k-1)
  + s^(k-1) * (1 + (s-2)*2)*(QAdiameter(k-1)+1);

  s*StarRep_wC_by_recurrence(s,k-1)
  + (2*s - 3)*(3*s)^(k-1);
}
StarRep_wC_by_recurrence = memoize(StarRep_wC_by_recurrence);

{
  my(s=5);
  check_exact(vector(100,k,k--; QAwC(k)), \
              vector(100,k,k--; StarRep_wC_by_recurrence(s,k)),
             "QAwC");
}

\\ g = s*x*g + ...
\\ g -s*x*g = ...
\\ g*(1 - s*x) = ...
\\ g = 1/(1 - s*x) * ...
gStarRep_wC(s,x) =
{
  1/(1 - s*x) * (  (2*s - 3) * x/(1 - 3*s*x)  );

  x * (2*s - 3)  / (1 - 3*s*x) / (1 - s*x);

  \\ A*(1 - s*x) + B*(1 - 3*s*x)
  \\ (-A - 3*B)*s*x + (A + B)
  \\ matsolve([-1*s,-3*s; 1,1],[2*s - 3; 0])
  \\ A=(2*s - 3)/(2*s); B=-(2*s - 3)/(2*s); (-A - 3*B)*s*x + (A + B)
  (2*s - 3)/(2*s) * ( 1/(1 - 3*s*x)   - 1/(1 - s*x) );
}
check_exact(gf_terms(gStarRep_wC('s,x), 20), \
            vector(20,k,k--; StarRep_wC_by_recurrence('s,k)));
check_exact(vector(20,s,s+=2; gf_terms(gStarRep_wC(s,x), 10)), \
            vector(20,s,s+=2; vector(10,k,k--; StarRep_wC_by_recurrence(s,k))));

StarRep_wC(s,k) = (2*s - 3)/(2*s) * s^k * (3^k - 1);

{
  check_exact(matrix(20,20,s,k,s+=2;k--; StarRep_wC(s,k)),
              matrix(20,20,s,k,s+=2;k--; StarRep_wC_by_recurrence(s,k)),
              "StarRep_wC");
}

gStarRep_wC_times_sk(s,x) = gStarRep_wC(s,s*x);
check_exact(gf_terms(gStarRep_wC('s,x), 10), \
            vector(10,k,k--; StarRep_wC('s,k)));
check_exact(vector(20,s,s+=2; gf_terms(gStarRep_wC_times_sk(s,x), 10)), \
            vector(20,s,s+=2; vector(10,k,k--; s^k*StarRep_wC(s,k))));

for(s=3,6, print(vector(5,k,k--; StarRep_wC(s,k))));
{
  my(s=5);
  check_exact(vector(100,k,k--; QAwC(k)),
              vector(100,k,k--; StarRep_wC(s,k)),
              "QAwC");
}
{
  for(i=3,#wC_samples,
     my(s=i-1);
     my(wC_row=wC_samples[i]);
     check_exact(vector(#wC_row,k,k--; StarRep_wC(s,k)),
                 wC_row,
                 Strprintf("wC_samples s=%d",s));
  );
}

\\------------------------------------------------------------------------------


StarRepW_by_recurrence(s,k) = {
  if(k==0,return(0));
  s* StarRepW_by_recurrence(s,k-1)
  + (s-1)          *( 2* s^(k-1)*StarRep_wC(s,k-1)
                      + (s^2)^(k-1)
                    )
  + binomial(s-1,2)*( 2* s^(k-1)*StarRep_wC(s,k-1)
                      + (s^2)^(k-1)*(QAdiameter(k-1)+2) 
                    );
}
{
  my(s=5);
  check_exact(vector(100,k,k--; QAW(k)), \
              vector(100,k,k--; StarRepW_by_recurrence(s,k)),
              "QAW");
}

{
  for(s=3,6,
     print(vector(5,k,k--; StarRepW_by_recurrence(s,k)));
  );
}

{
  for(i=1,#W_samples,
     my(s=i-1);
     my(W_row=W_samples[i]);
     check_exact(vector(#W_row,k,k--; StarRepW_by_recurrence(s,k)),
                 W_row,
                 Strprintf("StarRepW_by_recurrence vs W_samples s=%d",s));
  );
}

recurrence_guess(vector(100,k,k--; StarRepW_by_recurrence('s,k)));



\\ g = s*1/x*g + ...
\\ g -s/x*g = ...
\\ g*(1 -s/x) = ...
\\ g = 1/(1 - s/x) * ...
gStarRepW(s,x) =
{
  \\ 1/(1 - s/x)
  \\ * (
  \\    (s-1)
  \\    * ( 2 * 1/x*gStarRep_wC_times_sk(s,x)
  \\       + 1/s^2 * 1/(1-s^2*x)
  \\      )
  \\    + binomial(s-1,2)
  \\    * (  2 * 1/x*gStarRep_wC_times_sk(s,x)
  \\       + 1/(3*s^2) * 1/(1 - (3*s^2)*x)
  \\       + 1/s^2     * 1/(1 - s^2*x)
  \\      )
  \\   );

  x * ((s-1)^2 - 2*s^2*(s-1)*(s-4)*x)
  / (1 - (4*s+1)*(s*x) + s*(3*s+4)*(s*x)^2 - 3*s^2 *(s*x)^3);

  ((s^2 - 2*s + 1)*x - (2*s^3 - 2*s^2)*x^2)
  /
  (1 - (4*s^2 + s)*x + (3*s^4 + 4*s^3)*x^2 - 3*s^5*x^3);

  1/s *(
        1/2*(s-1)*(s+5)/(3*s-1)     * 1/(1 - 3*s^2*x)
        +   1/2 * (s-7)             * 1/(1 - s^2*x)
        - (2*s^2 - 9*s + 1)/(3*s-1) * 1/(1 - s*x)
       );

  ((s^2 - 2*s + 1)*x - (2*s^3 - 2*s^2)*x^2)
  / ( (1 - s*x)*(1 - s^2*x)*(1 - 3*s^2*x) );

  1/(6*s^2 - 2*s)
  * ( (3*s^2 - 8*s + 5)     * 1/(1 - 3*s^2*x)
     + (-3*s^2 + 10*s - 3)  * 1/(1 - s^2*x)
     + (-2*s - 2)           * 1/(1 - s*x) );

  1/2 * 1/( s * (3*s-1) )
  * ( (s-1)*(3*s-5)     * 1/(1 - 3*s^2*x)
     - (s-3)*(3*s-1)    * 1/(1 - s^2*x)
     - 2*(s+1)          * 1/(1 - s*x) );

  
  1/2 * (s-1)*(3*s-5)/( s * (3*s-1) )       * 1/(1 - 3*s^2*x)
  - 1/2 * (s-3) / s                         * 1/(1 - s^2*x)
  -  (s+1)/( s * (3*s-1) )                  * 1/(1 - s*x);
}
{
  check_exact(gf_terms(gStarRepW('s,x), 20), \
              vector(20,k,k--; StarRepW_by_recurrence('s,k)),
              "gStarRepW of 's");
}
check_exact(vector(3,s,s+=2; gf_terms(gStarRepW(s,x), 20)), \
            vector(3,s,s+=2; vector(20,k,k--; StarRepW_by_recurrence(s,k))));

my(s=1000);factor(1 - (4*s+1)*(s*x) + s*(3*s+4)*(s*x)^2 - 3*s^2 *(s*x)^3)

check_exact(1 - (4*s+1)*(s*x) + s*(3*s+4)*(s*x)^2 - 3*s^2 *(s*x)^3, \
            (1 - s*x)*(1 - s^2*x)*(1 - 3*s^2*x))

{
  \\ A*(1 - s^2*x)*(1 - 3*s^2*x))
  \\ B*(1 - s*x)*(1 - 3*s^2*x))
  \\ C*(1 - s^2*x)*(1 - 3*s^2*x))
  lindep([((s^2 - 2*s + 1)*x - (2*s^3 - 2*s^2)*x^2),
                   (1 - s^2*x)*(1 - 3*s^2*x),
         (1 - s*x)            *(1 - 3*s^2*x),
         (1 - s*x)*(1 - s^2*x)
         ])
}

StarRepW(s,k) =
{
  s^(k-1) *(
              1/2 * (s-1)*(3*s-5)/(3*s-1)   * (3*s)^k
            - 1/2 * (s-3)                   * s^k
            -       (s+1)/(3*s-1)
           ); 
}
{
  for(i=3,#W_samples,
     my(s=i-1);
     my(W_row=W_samples[i]);
     check_exact(vector(#W_row,k,k--; StarRepW(s,k)),
                 W_row,
                 Strprintf("W_samples s=%d",s));
  );
}

{
  check_exact(matrix(20,20,s,k,s+=2;k--; StarRepW(s,k)),
              matrix(20,20,s,k,s+=2;k--; StarRepW_by_recurrence(s,k)),
              "StarRepW");
}

\\-----------------------------------------------------------------------------
\\ limit

my(s=5); check_exact(1/s * 1/2*(s-1)*(3*s-5)/(3*s-1), 2/7);

StarRep_mean_limit(s) = ( 1/s * 1/2 * (s-1)*(3*s-5)/(3*s-1) ) / (1/2);

check_exact( (s-1)*(3*s-5)/(s * (3*s-1)), \
            StarRep_mean_limit(s));

vector(10,s,s+=2; StarRep_mean_limit(s))

for(s=3,40,print(StarRep_mean_limit(s)*1.0));

\\ so approaches 3/3 = 1
check_exact( (3*s^2 - 8*s + 5)/(3*s^2 - s), \
            StarRep_mean_limit(s));


quit
