\\ Copyright 2016, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

read("r5dragon-defines.gp");
check_exact(got,want) =
{
  if(got != want,
     print("wrong\n");
     print("got  " got);
     print("want " want);
     quit(1),
     print("ok"));
}

\\-----------------------------------------------------------------------------

\\ point(5*n+a) = b*point(n) + digitpoint(a)*I^dir(n)

is_integer(x) = (x==floor(x));                               
z_is_integer(z) = is_integer(real(z)) && is_integer(imag(z));
z_mod_b(z) = [0,3,4,1,2][((3*real(z) + imag(z)) % 5) + 1];

\\ d = direction 0 to 3 of segment leaving z
r5dragon_unpoint(z,d) = {
  my(debug=0);
  if(z==0,return([0,0]));
  my(v=List([]));  \\ digits low to high
  while(#v<6,  \\ ! (z==0 || z==-I) && 
    my(a=0, offset);
    while(a<5, 
          offset=digitpoint(a)*I^(d-dir(a));
          if(z_mod_b(z) == z_mod_b(offset),
             break());
          a++);
    if(a==5,error("a not found"));
    if(debug,print("at z="z"  d="d"  digit="a"  offset=",offset));
    z -= offset;
    z = z/b;
    d = (d - dir(a)) % 4;
    if(! z_is_integer(z), error("oops, z=",z));
    listput(v,a);
    );
  if(debug,print("end z="z" d="d" digits high to low "Vecrev(v)));
  v=Vecrev(v);
  if(z==0,  [d, fromdigits(v,5)],
     \\ z==-I,      [3, fromdigits(v,5)],
     \\ z==I        ,   [1, fromdigits(v,5)],
     \\ z==1 && s==-1, \\ v=apply(a->if(a==4,3, a==3,4, a),v);
     \\                [3, 5^#v-fromdigits(v,5)],
     ["end not recognised",z,d,v]
     \\ error("oops, r5dragon_unpoint() end z=",z," s=",s)
    );
}

r5dragon_unpoint(1, 1)
r5dragon_unpoint(1, 0)


{
  my(f=3);
  print("f="f);
  for(n=1,10,
     my(n_dir=dir(n));
     my(z=r5dragon_point(n) * I^f);
     print(n," base5=",digits(n,5)," ",z);
     for(d=0,3,
        my(d = (d+f)%4);
        my(anv=r5dragon_unpoint(z, d));
        my(arm=anv[1]);
        my(an=anv[2]);
        my(none= type(arm)=="t_STR");
        my(zz=if(none,0, r5dragon_point(an) * I^arm));
        my(zdiff=if(none || z==zz, ""," ***diff"));
        print("  d="d"  "anv"  zz="zz,zdiff);
     );
  );
}
