#!/usr/bin/perl -w

# Copyright 2017 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


use 5.004;
use strict;

use FindBin;
use lib $FindBin::Bin;
use MyR5Dragon;
use MyPrintwrap ':all';


my $level = 4;
if (@ARGV) { $level = shift @ARGV; }

print "  % generated by tools/$FindBin::Script $level\n";

sub draw {
  my ($k, $x,$y) = @_;
  my $len = 3**$k;
  if ($k == 1) {
    my $x1 = $x-$len;
    my $x2 = $x+$len;
    printwrap(" ($x1,$y)--($x2,$y)");
    my $y1 = $y-$len;
    my $y2 = $y+$len;
    printwrap(" ($x,$y1)--($x,$y2)");
  } else {
    draw ($k-1, $x,     $y);
    draw ($k-1, $x-$len,$y);
    draw ($k-1, $x+$len,$y);
    draw ($k-1, $x,     $y-$len);
    draw ($k-1, $x,     $y+$len);
  }
}

$Printwrap = 2;
printwrap("\\draw");
$Printwrap += 2;
draw($level, 0,0);
printwrap(";\n");

print "  % end generated\n";
exit 0;
