#!/usr/bin/perl -w

# Copyright 2017 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


use 5.004;
use strict;
use Math::PlanePath::R5DragonCurve 117; # v.117 for level_to_n_range()

use FindBin;
use lib $FindBin::Bin;
use MyR5Dragon 'mul';
use MyPrintwrap ':all';


my $level = 7;
if (@ARGV) { $level = shift @ARGV; }

print "  % generated by tools/$FindBin::Script $level\n";
print "  \\newcommand{\\MyLevel}{$level}\n";

my $ex = 1;
my $ey = 0;

my $points = [ [0,0], [$ex,$ey] ];
foreach my $j (1 .. $level) {
  $Printwrap = 2;
  printwrap("\\draw ");
  $Printwrap += 2;
  my $join = '';
  my ($prev_x,$prev_y) = @{$points->[-1]};
  my $i = 1;
  foreach my $p (@$points) {
    my ($x,$y) = @$p;
    foreach ($j+1 .. $level) {
      ($x,$y) = mul($x,$y);
    }
    printwrap("($x,$y)--");
  }
  printwrap("cycle;\n");

  ($points,$ex,$ey) = MyR5Dragon::hull_expand($points,$ex,$ey);
}

print "  % end generated\n";
exit 0;
