#!/usr/bin/perl -w

# Copyright 2014, 2016, 2017, 2018 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


use 5.004;
use strict;

use FindBin;
use lib $FindBin::Bin;
use MyPrintwrap ':all';


print "  % generated by tools/$FindBin::Script\n";

my $s = 3;

foreach my $i (0 .. $s) {
  $Printwrap = 2;
  printwrap("\\draw (0-\\MyEdge,$i)--($s+\\MyEdge,$i) ($i,0-\\MyEdge)--($i,$s+\\MyEdge);\n");

  # dots
  $Printwrap += 2;
  foreach my $j (0 .. $s) {
    printwrap(" \\fill ($i,$j)circle;");
  }
  printwrap_newline();
}

print "  \\begin{scope}[shift=(right-pos)]\n";

$Printwrap = 2;
foreach my $i (0 .. $s) {
  # dots
  foreach my $j (0 .. $s) {
    printwrap(" \\fill ($i,$j)circle;");
  }
  printwrap_newline();
}

foreach my $i (0 .. $s) {
  if (0) {
    # top lines
    $Printwrap = 4;
    printwrap("\\draw[dashed] (0,$i)");
    $Printwrap += 2;
    foreach my $j (1 .. $s) {
      printwrap("--($j-.2,$i+.4)");
      my $end = ($j == $s ? ';' : '');
      printwrap("--($j,$i)$end");
    }
    printwrap_newline();

    # bottom lines
    $Printwrap = 4;
    printwrap("\\draw[dashed] (0,$i)");
    $Printwrap += 2;
    foreach my $j (1 .. $s) {
      printwrap("--($j-.8,$i-.4)");
      my $end = ($j == $s ? ';' : '');
      printwrap("--($j,$i)$end");
    }
    printwrap_newline();

    # left lines
    $Printwrap = 4;
    printwrap("\\draw[dashed] ($i,0)");
    $Printwrap += 2;
    foreach my $j (1 .. $s) {
      printwrap("--($i-.4,$j-.2)");
      my $end = ($j == $s ? ';' : '');
      printwrap("--($i,$j)$end");
    }
    printwrap_newline();

    # right lines
    $Printwrap = 4;
    printwrap("\\draw[dashed] ($i,0)");
    $Printwrap += 2;
    foreach my $j (1 .. $s) {
      printwrap("--($i+.4,$j-.8)");
      my $end = ($j == $s ? ';' : '');
      printwrap("--($i,$j)$end");
    }
    printwrap_newline();
  }

  # dashed S shapes
  #
  #       0  .4   .8
  #
  #   .4        __*
  #           *-   \      .2
  #   0   *    \    *
  #        \ __-* -      -.2
  #  -.4    *
  #
  #        .2   .6   1
  #
  #    .5-5a .5-a .5+3a       a=.1*f
  #
  #  4a         __*               .8*.8=.64
  #           *-   \       2a
  #   0   *    \    *
  #        \ __-* -       -2a
  #  -4a    *
  #
  #        .26   .58  .9
  #
  if (0) {
    my $f = .9;
    $Printwrap = 4;
    foreach my $j (0 .. $s-1) {
      printwrap("\\draw ");
      $Printwrap += 2;
      printwrap(  "($j+.5-.5*$f, $i)");
      printwrap("--($j+.5-.3*$f, $i-.4*$f)");
      printwrap("--($j+.5+.1*$f, $i-.2*$f)");
      printwrap("--($j+.5-.1*$f, $i+.2*$f)");
      printwrap("--($j+.5+.3*$f, $i+.4*$f)");
      printwrap("--($j+.5+.5*$f, $i);\n");
      $Printwrap = 4;
    }
    printwrap_newline();

    $Printwrap = 4;
    foreach my $j (0 .. $s-1) {
      printwrap("\\draw ");
      $Printwrap += 2;
      printwrap(        "($i, $j+.5-.5*$f)");
      printwrap("--($i+.4*$f, $j+.5-.3*$f)");
      printwrap("--($i+.2*$f, $j+.5+.1*$f)");
      printwrap("--($i-.2*$f, $j+.5-.1*$f)");
      printwrap("--($i-.4*$f, $j+.5+.3*$f)");
      printwrap(      "--($i, $j+.5+.5*$f);\n");
      $Printwrap = 4;
    }
    printwrap_newline();
  }

  {
    my $c = '.2';
    $Printwrap = 2;
    printwrap("\\draw (-\\MyEdgeExp/2, $i+\\MyEdgeExp)\n");
    $Printwrap += 2;
    my $join = '';
    foreach my $j (0 .. $s-1) {
      # printwrap("$join($j, $i)");                 # \ dx=.2, dy=-.4
      printwrap("--($j+.2-.2*$c, $i-.4+.4*$c)");    # /
      printwrap("--($j+.2+.4*$c, $i-.4+.2*$c)");    # \ dx=.4  dy=.2
      printwrap("--($j+.6-.4*$c, $i-.2-.2*$c)");    # /
      printwrap("--($j+.6-.2*$c, $i-.2+.4*$c)");    # \ dx=-.2 dy=.4
      printwrap("--($j+.4+.2*$c, $i+.2-.4*$c)");    # /
      printwrap("--($j+.4+.4*$c, $i+.2+.2*$c)");    # \ dx=.4 dy=.2
      printwrap("--($j+.8-.4*$c, $i+.4-.2*$c)");    # /
      printwrap("--($j+.8+.2*$c, $i+.4-.4*$c)\n");  # \ dx=.2 dy=-.4
      $join = '--';
    }
    printwrap("--($s+\\MyEdgeExp/2, $i-\\MyEdgeExp);\n");

    $Printwrap -= 2;
    printwrap("\\draw ($i-\\MyEdgeExp, 0-\\MyEdgeExp/2)\n");
    $Printwrap += 2;
    $join = '';
    foreach my $j (0 .. $s-1) {
      my $end = ($j == $s-1 ? ';' : '');
      # printwrap("$join($i, $j)");                 # \ dx=.4, dy=.4
      # $Printwrap = 8;
      printwrap("--($i+.4-.4*$c, $j+.2-.2*$c)");   # /
      printwrap("--($i+.4-.2*$c, $j+.2+.4*$c)");   # \ dx=-.2, dy=.4
      printwrap("--($i+.2+.2*$c, $j+.6-.4*$c)");   # /
      printwrap("--($i+.2-.4*$c, $j+.6-.2*$c)");   # \ dx=-.4, dy=-.2
      printwrap("--($i-.2+.4*$c, $j+.4+.2*$c)");   # /
      printwrap("--($i-.2-.2*$c, $j+.4+.4*$c)");   # \ dx=-.2, dy=.4
      printwrap("--($i-.4+.2*$c, $j+.8-.4*$c)");   # /
      printwrap("--($i-.4+.4*$c, $j+.8+.2*$c)\n"); # \ dx=-.4, dy=.2
      $join = '--';
    }
    printwrap("--($i+\\MyEdgeExp, $s+\\MyEdgeExp/2);\n");
  }

  # $Printwrap = 4;
  # foreach my $j (0 .. $s-1) {
  #   printwrap("\\draw ");
  #   $Printwrap += 2;
  #   printwrap(        "($i, $j+.5-.5*$f)");
  #   printwrap("--($i+.4*$f, $j+.5-.3*$f)");
  #   printwrap("--($i+.2*$f, $j+.5+.1*$f)");
  #   printwrap("--($i-.2*$f, $j+.5-.1*$f)");
  #   printwrap("--($i-.4*$f, $j+.5+.3*$f)");
  #   printwrap(      "--($i, $j+.5+.5*$f);\n");
  #   $Printwrap = 4;
  # }
  # printwrap_newline();

}
print "  \\end{scope}\n";

print "  % end generated\n";
exit 0;
